/********************************/
/* wĩOtBbNύX */
/********************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		i,j,k,m,c;
	int		dt[24];
	int		sft;
	int		dttmp[8][8];
	int		dto[8][4],dtout;
	int		dt_b;
	int		dsw;
	int		startadd,endadd;


	if (argc != 5) {
		fprintf(stderr, "Usage: conv_bk startadd endadd inputfile outputfile\n");
		exit(1);
	}

/* open files */

	sscanf(argv[1],"%x",&startadd);
	sscanf(argv[2],"%x",&endadd);

	if ((infp = fopen(argv[3], "rb")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	if ((outfp = fopen(argv[4], "wb")) == NULL) {
		perror(argv[4]);
		exit(1);
	}

	for (i = 0;i < startadd;i ++) {
		if ( (c = fgetc(infp)) == EOF) {
			break;
		}
		fputc(c,outfp);
	}

	j = 0;
	for (;i < endadd;i ++) {
		if ( (c = fgetc(infp)) == EOF) {
			break;
		}
		dt[j] = c;
		if (j == 23) {

/* dt[0]: */
/* dt[1]: */
/* dt[2]: */
/* dt[3]: */
/* dt[4]: */
/* dt[5]: */

			for (k = 0;k < 4;k ++) {
				dsw       = dt[3+k*6];
				dt[3+k*6] = dt[5+k*6];
				dt[5+k*6] = dsw;
			}

			for (k = 0;k < 8;k ++) {
				sft = 0x80;
				for (m = 0;m < 8;m ++) {
					dttmp[k][m] = 0x08;
					if ( (dt[k*3+2] & sft) != 0) {		/*  */
						dttmp[k][m] |= 0x04;
					}
					if ( (dt[k*3+1] & sft) != 0) {		/*  */
						dttmp[k][m] |= 0x02;
					}
					if ( (dt[k*3+0] & sft) != 0) {		/*  */
						dttmp[k][m] |= 0x01;
					}
					sft = sft >> 1;
				}
			}

/* WhbgShbgpɊԈ */

			for (k = 0;k < 8;k ++) {
				for (m = 0;m < 4;m ++) {
					dto[k][m] = dttmp[k][m*2];
				}
			}

/* Whbgł̎Ȗ͗ĺAShbgŊiq͗lɕϊ */
/*
/* [0] [1] [2] [3] */
/*  R   B   R   B  */
/*       
/*   [0]     [1]   */
/*    R       B    C */
/*    B       R    C */

			for (k = 0;k < 8;k ++) {
				if (
					(dttmp[k][7] == dttmp[k][5]) &&
					(dttmp[k][6] == dttmp[k][4])
				) {

					if ( (k%2) == 0) {
						dto[k][3] = dttmp[k][7];
						dto[k][2] = dttmp[k][6];
					} else {
						dto[k][3] = dttmp[k][6];
						dto[k][2] = dttmp[k][7];
					}

				}

				if (
					(dttmp[k][3] == dttmp[k][1]) &&
					(dttmp[k][2] == dttmp[k][0])
				) {

					if ( (k%2) == 0) {
						dto[k][1] = dttmp[k][3];
						dto[k][0] = dttmp[k][2];
					} else {
						dto[k][1] = dttmp[k][2];
						dto[k][0] = dttmp[k][3];
					}

				}
			}

/* [0][0] [0][1] [0][2] [0][3] */
/* [1][0] [1][1] [1][2] [1][3] */
/*                           */
/* 0000_[0][0] 0000_[0][1] [0][3]_[0][2] */
/* 0000_[1][0] 0000_[1][1] [1][3]_[1][2] */

			for (k = 0;k < 8;k ++) {
				fputc(dto[k][0], outfp);
				fputc(dto[k][1], outfp);
				fputc((dto[k][2] | (dto[k][3] * 0x10)), outfp );
			}

			j = 0;
		} else {
			j ++;
		}
	}

	while ( (c = fgetc(infp)) != EOF) {
		fputc(c,outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);

}

