#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	640
#define	MAXHEIGHT	200

void	fput4b(int,FILE *);
void	fput2b(int,FILE *);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel[MAXWIDTH][MAXHEIGHT];

	int		width,height;
	int		x,y,i,j;
	int		a0,a1,a2,a3,a4,a5,a6,a7;
	int		c,c1,c2;
	int		sft;
	int		pl,col;
	int		outhigh,eqlen,deqlen;
	int		outdt4b;
	int		d0,d1;
	int		x00,y00,x11,y11;

	if (argc != 3 && argc != 4) {
		fprintf(stderr, "Usage: convpict infile outfile [colnum]\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	col = 0xff;
	if (argc == 4) {
		col = atoi(argv[3]);
	}

	x00 = fgetc(infp);
	y00 = fgetc(infp);
	x11 = fgetc(infp);
	y11 = fgetc(infp);

	width  = (x11-x00)*8;
	height = (y11-y00);

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			pixel[x][y] = 0x08;
		}
	}

	x = 0;
	y = 0;
	pl = 0x01;
	while ( (c = fgetc(infp)) != EOF) {
		if (c == 0x00) {
			break;
		}
		if (c < 0x80) {
			for (i = 0;i < c;i ++) {

				c1 = fgetc(infp);

				sft = 0x80;
				for (j = 0;j < 8;j ++) {
					c2 = ( (c1 & sft) == 0 ? 0x00 : pl);
					pixel[x+j][y] |= c2;
					sft /= 2;
				}

				y ++;
				if (y >= height) {
					y = 0;
					x += 8;
					if (x >= width) {
						x = 0;
						pl *= 2;
					}
				}

			}
		} else {
			c -= 0x80;
			c1 = fgetc(infp);
			for (i = 0;i < c;i ++) {

				sft = 0x80;
				for (j = 0;j < 8;j ++) {
					c2 = ( (c1 & sft) == 0 ? 0x00 : pl);
					pixel[x+j][y] |= c2;
					sft /= 2;
				}

				y ++;
				if (y >= height) {
					y = 0;
					x += 8;
					if (x >= width) {
						x = 0;
						pl *= 2;
					}
				}

			}

		}

	}

	fclose(infp);


/* wi̐Fς */
	if (col != 0xff) {
		for (y = 0;y < height;y ++) {
			for (x = 0;x < width;x += 2) {
				a0 = pixel[x+0][y];
				a1 = pixel[x+1][y];
				if (a0 == 0x08 && a1 == 0x0c) {
					pixel[x+0][y] = col;
					pixel[x+1][y] = col;
				}
			}

		}
		col = 0x05;
	} else {
		col = 0x0c;
	}



/* cȂ`FbJ[͗lɕύX */
	for (y = 0;y < height;y ++) {
		a5 = 0xff;
		a6 = 0xfe;
		a7 = 0xfd;
		for (x = 0;x < width;x += 4) {
			a0 = pixel[x+0][y];
			a1 = pixel[x+1][y];
			a2 = pixel[x+2][y];
			a3 = pixel[x+3][y];

											/* 5 6 7 0 1 2 3 */
			if (a0 == a2 && a1 == a3) {		/*       A B A B */
				if ((y%2) == 0) {			/*        A   B  */
					pixel[x+0][y] = a0;
					pixel[x+2][y] = a1;
				} else {					/*        B   A  */
					pixel[x+0][y] = a1;
					pixel[x+2][y] = a0;
				}
			}

											/* 5 6 7 0 1 2 3 */
			if (a0 == a6 && a1 == a7) {		/*   A B A B     */
				if ((y%2) == 0) {			/*    B   A      */
					pixel[x+0][y] = a0;
					pixel[x-2][y] = a1;
				} else {					/*    A   B      */
					pixel[x+0][y] = a1;
					pixel[x-2][y] = a0;
				}
			}

											/* 5 6 7 0 1 2 3 */
			if (a0 == a2 && a1 == a7) {		/*     B A B A   */
				if ((y%2) == 0) {			/*        A   B  */
					pixel[x+0][y] = a0;
					pixel[x+2][y] = a1;
				} else {					/*        B   A  */
					pixel[x+0][y] = a1;
					pixel[x+2][y] = a0;
				}
			}

											/* 5 6 7 0 1 2 3 */
			if (a0 == a6 && a7 == a5) {		/* B A B A       */
				if ((y%2) == 0) {			/*    B   A      */
					pixel[x+0][y] = a0;
					pixel[x-2][y] = a7;
				} else {					/*    A   B      */
					pixel[x+0][y] = a7;
					pixel[x-2][y] = a0;
				}
			}

			a5 = a1;
			a6 = a2;
			a7 = a3;

		}
	}


	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	fputc( y00, outfp);
	fputc( y11-y00, outfp);
	fput2b( x00*4, outfp);
	fput2b( (x11-x00)*4, outfp);
	fputc( col, outfp);


/* f[^k */
/*
Ef[^́ASrbgP
E1st 0x8 ȏȂÂ܂܂̃f[^

E1st 0x0 ȂPoCgk
E2nd 0x4`0xF ȂA3rd 2nd JԂ
E2nd 0x0 ȂA3rd  16 JԂ
E2nd 0x1 ȂA3rd  32 JԂ
E2nd 0x2 ȂA3rd  64 JԂ
E2nd 0x3 ȂA3rd  128 JԂ

E1st 0x1`0x7 ȂQoCgk
E1st 0x3`0x7 ȂA2ndA3rd1stJԂ
E1st 0x1 ȂA2ndA3rd16JԂ
E1st 0x2 ȂA2ndA3rd32JԂ

EPŊBSrbgPʂŗ]ꍇ́AŌ 0x0 𖄂߂B
*/

	for (y = 0;y < height;y ++) {
		outhigh = 1;
		for (x = 0;x < width/2;) {

		// oCǧo
			eqlen = 0;
			a0 = pixel[x*2][y];
			for (i = x;i < width/2;i ++) {
				a1 = pixel[i*2][y];
				if (a0 != a1) {
					break;
				}
				eqlen ++;
			}

		// QoCgǍo
			deqlen = 0;
			if (x+3 < width/2) {
				a0 = pixel[x*2][y];
				a1 = pixel[x*2+2][y];
				for (i = x;i < width/2-1;i +=2) {
					a2 = pixel[i*2][y];
					a3 = pixel[i*2+2][y];
					if (a0 != a2 || a1 != a3) {
						break;
					}
					deqlen ++;
				}
			}


			if (eqlen >= 4) {			// PoCgk

				outdt4b = 0x00;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				if (eqlen >= 128) {
					outdt4b = 0x03;
				} else if (eqlen >= 64) {
					outdt4b = 0x02;
				} else if (eqlen >= 32) {
					outdt4b = 0x01;
				} else if (eqlen >= 16) {
					outdt4b = 0x00;
				} else {
					outdt4b = eqlen;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				if (eqlen >= 128) {
					x += 128;
				} else if (eqlen >= 64) {
					x += 64;
				} else if (eqlen >= 32) {
					x += 32;
				} else if (eqlen >= 16) {
					x += 16;
				} else {
					x += eqlen;
				}

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

			} else if (deqlen >= 3) {		// QoCgk

				if (deqlen >= 32) {
					outdt4b = 0x02;
				} else if (deqlen >= 16) {
					outdt4b = 0x01;
				} else if (deqlen >= 8) {
					outdt4b = 0x07;
				} else {
					outdt4b = deqlen;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				if (deqlen >= 32) {
					x += 32*2;
				} else if (deqlen >= 16) {
					x += 16*2;
				} else if (deqlen >= 8) {
					x += 7*2;
				} else {
					x += deqlen*2;
				}

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a1;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

			} else {					// kȂ

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}
				x ++;

			}

		}

		outdt4b = 0x00;
		if (outhigh != 1) {
			d1 = (outdt4b & 0x0f);
			fputc(d0|d1,outfp);
		}

	}

	fclose(outfp);
	return(0);
}

void	fput4b(int d,FILE *fp)
{
	int	d0,d1,d2,d3;

	d0 = (d & 0x000000ff);
	d1 = (d & 0x0000ff00) >> 8;
	d2 = (d & 0x00ff0000) >> 16;
	d3 = (d & 0xff000f00) >> 24;

	fputc(d0,fp);
	fputc(d1,fp);
	fputc(d2,fp);
	fputc(d3,fp);

	return;
}

void	fput2b(int d,FILE *fp)
{
	int	d0,d1;

	d0 = (d & 0x00ff);
	d1 = (d & 0xff00) >> 8;

	fputc(d0,fp);
	fputc(d1,fp);

	return;
}

