/**************************/
/* ̕тύX */
/* MI1.CHR`MI6.CHR       */
/**************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		i,j,c;
	int		fileno;

	char	mgword[6][13][21] = {
		{
			"     Fire Ball      ",	// 1
			"    Flying Disk     ",	// 2
			"   Lightning Bolt   ",	// 3
			"    Fire Element    ",	// 4
			"       Press        ",	// 5
			"       Spark        ",	// 6
			"     Ice Breath     ",	// 7
			"     Heat Body      ",	// 8
			"   Fire Explosion   ",	// 9
			"    Thunder Bolt    ",	// 10
			"    Killer Cloud    ",	// 11
			"    Death Spell     ",	// 12
			"      Big Burn      "	// 13
		},{
			"       Shield       ",	// 1
			"     Protection     ",	// 2
			" Neutralize Spell I ",	// 3
			"  Reflect Spell I   ",	// 4
			"   Shield Redline   ",	// 5
			"  Protection Large  ",	// 6
			"Neutralize Spell II ",	// 7
			"  Reflect Spell II  ",	// 8
			"  Shield Blueline   ",	// 9
			"   Sword Barrier    ",	// 10
			"     High Speed     ",	// 11
			"                    ",	// 12
			"                    "	// 13
		},{
			"       Sleep        ",	// 1
			"    Rock Hold I     ",	// 2
			"      Silence       ",	// 3
			"    Smoke Screen    ",	// 4
			"    Rock Hold II    ",	// 5
			"       Panic        ",	// 6
			"    Rock to Mud     ",	// 7
			"    Wizard Lock     ",	// 8
			"                    ",	// 9
			"                    ",	// 10
			"                    ",	// 11
			"                    ",	// 12
			"                    "	// 13
		},{
			" Identify Monster I ",	// 1
			"    Idetify Door    ",	// 2
			"   Detect Monster   ",	// 3
			"     Detect Key     ",	// 4
			"    Detect Magic    ",	// 5
			"   Find Trap Door   ",	// 6
			"Identify Monster II ",	// 7
			"Find Secret Passage ",	// 8
			"Detect Magic Ladder ",	// 9
			"                    ",	// 10
			"                    ",	// 11
			"                    ",	// 12
			"                    "	// 13
		},{
			"       Heal I       ",	// 1
			"       Cure I       ",	// 2
			"      Antidote      ",	// 3
			"      Heal II       ",	// 4
			"      Cure II       ",	// 5
			"     First Aid      ",	// 6
			"      Heal III      ",	// 7
			"      Cure III      ",	// 8
			"   Super Antidote   ",	// 9
			"      Heal IV       ",	// 10
			"      Cure IV       ",	// 11
			"      Recover       ",	// 12
			"                    "	// 13
		},{
			"  Blue Crystal Rod  ",	// 1
			"      Call GIL      ",	// 2
			"     See Status     ",	// 3
			"   Dispell Magic    ",	// 4
			"     Write Mark     ",	// 5
			"Extrasensory Hearing",	// 6
			"   Duo Dimension    ",	// 7
			"   Unseen Servant   ",	// 8
			"    Metamorphose    ",	// 9
			"     Time Stop      ",	// 10
			"   Reincarnation    ",	// 11
			"                    ",	// 12
			"                    "	// 13
		}

	};

	char mgcat[6][8] = {
		"ATTACK ",
		"PROTECT",
		"ASSIST ",
		"LIGHT  ",
		"MEDICAL",
		"SPECIAL"
	};


	if (argc != 4) {
		fprintf(stderr, "Usage: conv_mi fileno inputfile outputfile\n");
		exit(1);
	}

/* open files */

	fileno = atoi(argv[1]) - 1;

	if ((infp = fopen(argv[2], "rb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if ((outfp = fopen(argv[3], "wb")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	for (i = 0;i < 7;i ++) {
		fputc(mgcat[fileno][i],outfp);
	}
	fputc(0x00,outfp);

	for (i = 0;i < 13;i ++) {
		for (j = 0;j < 20;j ++) {
			fputc(mgword[fileno][i][j],outfp);
		}
		fputc(0x00,outfp);
	}

	for (i = 0;i < 161;i ++) {
		fputc(0x00,outfp);
	}

	fseek(infp, 0x01ba, SEEK_SET);

	while ( (c = fgetc(infp)) != EOF) {
		fputc(c,outfp);
	}


	fclose(infp);
	fclose(outfp);

	return(0);

}

