;
; Np
;

	relaxed on

Disk_Init	equ	Disk60_Entry+0
Disk_Change1DD	equ	Disk60_Entry+12

DOS_INIT	equ	$d200
FILEREAD	equ	$d200+3

JOYMODE		equ	$d326


	org	$c000

;
; Track#0 Sector#1`2
;
	db	"IPL"		; +0
	jr	START		; +3

;
; ZN^ǂݍ݁iROM[`gpj
;
READ_NSEC:
.loop:
	push	af
	ld	a,$01
	or	a
	push	bc
	push	de
	call	$0198		; ZN^ǂݍ
	pop	de
	pop	bc
	inc	d
	inc	c
	pop	af
	dec	a
	jr	nz,.loop
	ret

;
; ʃNA
;
CURCLS:
	ld	hl,$f000
	ld	(hl),$20
	inc	hl
	ld	(hl),$0f
	inc	hl
	ld	de,$f000
	ex	de,hl
	ld	bc,40*25*2-1
	ldir
	ret

START:
	xor	a		; hCuԍ-1
	ld	($ed66),a

	ld	bc,$0002	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,$c100	; i[AhX
	ld	a,$01		; ǂݍރZN^
	call	READ_NSEC

	call	CURCLS

; @I
;

	ld	de,KEY_TITLE
	ld	hl,$f000+9*2+3*80
	call	PNT_MSG

	ld	hl,$f000+12*2+6*80
	call	PNT_MSG			; DE=KEY_KI

	ld	hl,$f000+20*2+6*80
	call	PNT_MSG			; DE=KEY_GIL

	ld	b,5
	ld	hl,$f000+7*2+8*80
.meslp:
	call	PNT_MSG			; DE=KEY_JOY

	push	de
	ld	de,80-21*2
	add	hl,de
	pop	de

	djnz	.meslp

	ld	hl,$f000+10*2+15*80
	call	PNT_MSG			; DE=KEY_MAN

.nokey:
	call	$011a		; L[{[hP
	jr	z,.nokey
	sub	"0"
	jr	c,.nokey
	cp	5
	jr	nc,.nokey

	dec	a
	ld	(.joymd+1),a

	call	CURCLS

	ld	c,$03		; Creg:ZN^ԍihCupǂݏo[`j

	ld	a,($ed5a)	; bit7`0 = Ot#2A#1A#2A#1A"0000"
	bit	4,a
	jr	nz,.fd_in
	ld	c,$05		; Creg:ZN^ԍiOthCupǂݏo[`j

.fd_in:
	ld	b,$00		; Breg:gbNԍ
	ld	de,$d000	; i[擪AhX
	ld	a,$02		; ǂݍރZN^

			; ^OthCuǂݏo
	call	READ_NSEC

	ld	bc,$0007	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,$d200	; i[AhX
	ld	a,$04		; ǂݍރZN^
			; t@Cǂݏo[`
	call	READ_NSEC

	ld	d,$00
	call	Disk_Init
	jr	c,.diskng

	ld	d,$00
	call	Disk_Change1DD
	jr	c,.diskng

	di

	ld	sp,$d5a8

;
; 0x0000`0xBFFF̃Ot
;
;
	ld	b,$06
	ld	de,$6068
	ld	a,$20
.outlp1:
	ld	c,d
	out	(c),a
	ld	c,e
	out	(c),a
	inc	a
	inc	a
	inc	d
	inc	e
	djnz	.outlp1

	ld	bc,$5aa5
	ld	hl,$0000
	ld	(hl),b
	ld	h,$80
	ld	(hl),c

	ld	h,$00
	ld	a,(hl)
	cp	b
	jr	nz,.ramng
	ld	h,$80
	ld	a,(hl)
	cp	c
	jr	z,.ramok

.ramng:
	ld	de,RAMNG_MSG
	ld	hl,$f000
	call	PNT_MSG
	jr	$

.ramok:
	ld	hl,$0000	; i[AhX
	ld	de,FILE1	; t@C
	ld	c,$03		; ǂݏoAsȂ
	call	FILEREAD

	ld	hl,$a000	; i[AhX
	ld	de,FILE2	; t@C
	ld	c,$03		; ǂݏoAsȂ
	call	FILEREAD

	call	DOS_INIT
.joymd:	ld	a,$ff
	ld	(JOYMODE),a
	jp	$a000


.diskng:
	ld	de,DISKNG_MSG
	ld	hl,$f000
	call	PNT_MSG
	jr	$


FILE1:
	db	"SYSP6.Z80",$00

FILE2:
	db	"BOOTP6.Z80",$00

DISKNG_MSG:
	db	"Disk error",$00

RAMNG_MSG:
	db	"64K",$e9,$20				; USj
	db	"RAM",$96,$de,$20			; q`lJ
	db	$eb,$e2,$f6,$93,$e3,$de,$9d,$a1,$00	; Ђ悤āJB

KEY_TITLE:
	db	$9f,$93,$9b,$ee,$93,$ee,$93,$86,$20	; قق
	db	$94,$f7,$fd,$e3,$de			; āJ
	db	$98,$e0,$de,$9b,$92,$00			; J

KEY_KI:
	db	"KI",$00

KEY_GIL:
	db	"GIL",$00

KEY_JOY:
	db	"1:JOYSTICK1 KEYBOARD ",$00
	db	"2: KEYBOARD JOYSTICK1",$00
	db	"3:JOYSTICK1 JOYSTICK2",$00
	db	"4:      XPD-1LR      ",$00
	db	"0: ø",$e6,$20			; tKeNg
	db	$eb,$8f,$96,$96,$8f,$e3,$f0,$f9,$00	; ЂĂ݂

KEY_MAN:
	db	"1-4",$e9			; P|S
	db	"",$86,$20			; L[
	db	$95,$9c,$e3			; 
	db	$98,$e0,$de,$9b,$92,$00		; J



PNT_MSG:
.msglp:
	ld	a,(de)
	inc	de
	or	a
	ret	z
	ld	(hl),a
	inc	hl
	inc	hl
	jr	.msglp



	org	$c200
;
; Track#0 Sector#2-3
;

	phase	$d000
	include	"disk66.z80"	; hCupǂݏo[`


	org	$c400
;
; Track#0 Sector#4-5
;

	phase	$d000
	include	"disk.z80"	; OthCupǂݏo[`


	org	$c5ff
	db	$00


end

